#!/usr/bin/gawk -f
{

        ## some html escapes:
        gsub("&gt;",">")
        gsub("&lt;","<")
        gsub("&quot;","\"")
        gsub("&rdquo;","\"")
        gsub("&bdquo;","\"")
        gsub("&lsquo;","\"")
        gsub("&rsquo;","\"")
	gsub("&sbquo;",",")
        gsub("&amp;","\\&")

	## replace fancy "smart" quotes with straight equivalents
        gsub("’","'")
        gsub("‘","'")

        gsub("“","\"")
        gsub("”","\"")

        gsub("„","\"")
        gsub("„","\"")

		
	## backquote to apostrophe
	gsub("`","'")	

	## double quote to apostrophe
        gsub("\"","'")
		
	## select illegal filename characaters replaced by alternates  (other illegal characters just dropped later)
        gsub(">",")")
        gsub("<","(")
        gsub("[:]"," - ")
        gsub("[/]","-")
		## backslash to dash
	gsub("\\\\","-")

        gsub("[?]","")
        gsub("[|]","-")
        gsub("*","+")
	
        ## double space to single space:
        gsub("  "," ")


        ## sanitize the rest:
        ## gsub("[^- '[:alnum:] _$+&={}\\[\\]()%@!;,.]*","")

	gsub("^[[:blank:]]*", "")
	gsub("[[:blank:]]*$", "")

        ## dump it to stdout
        print
}